# 
# xenopy.log - Generic jabber handling code
# Copyright (C) 2005 Jason Chu <jason@archlinux.org>
# 
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
# 

import logging,sys,os.path

lg = None

def init(appname):
	global lg
	lg = logging.getLogger(appname)
	handler = logging.StreamHandler(sys.stderr)
	lg.addHandler(handler)
	handler = logging.FileHandler(os.path.expanduser("~/.xenophile/%s.log" % appname))
	lg.addHandler(handler)
	lg.setLevel(logging.INFO)
	lg.info("--- Logging started for %s ---" % appname)

def logInit(fun):
	def decorate(f):
		if lg == None:
			init(os.path.basename(sys.argv[0]))
		return fun(f)
	return decorate

@logInit
def debug(msg):
	lg.debug(msg)
@logInit
def info(msg):
	lg.info(msg)
@logInit
def warning(msg):
	lg.warning(msg)
@logInit
def error(msg):
	lg.error(msg)
@logInit
def critical(msg):
	lg.critical(msg)
